Index: LMDZ5/branches/testing/libf/dyn3dmem/gcm.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/gcm.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/gcm.F90	(revision 2641)
@@ -21,4 +21,10 @@
   USE iniphysiq_mod, ONLY: iniphysiq
 #endif
+  USE comconst_mod, ONLY: cpp, daysec, dtphys, dtvr, g, r, rad
+  USE logic_mod ! all of it, because of copyin clause when calling leapfrog
+  USE temps_mod, ONLY: calend,start_time,annee_ref,day_ref, &
+                       itau_dyn,itau_phy,day_ini,jD_ref,jH_ref,day_end, &
+                       dt,hour_ini,itaufin
+
   IMPLICIT NONE
 
@@ -54,14 +60,7 @@
   include "dimensions.h"
   include "paramet.h"
-  include "comconst.h"
   include "comdissnew.h"
-  include "comvert.h"
   include "comgeom.h"
-  include "logic.h"
-  include "temps.h"
-  include "ener.h"
   include "description.h"
-  include "serre.h"
-  !include "com_io_dyn.h"
   include "iniprint.h"
   include "tracstoke.h"
@@ -452,5 +451,14 @@
   !       write(78,*) 'q',q
 
-  !$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/,/logici/,/logicl/)
+  !!$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/,/logici/,/logicl/)
+  !$OMP PARALLEL DEFAULT(SHARED) &
+  !     Copy all threadprivate variables in temps_mod
+  !$OMP COPYIN(dt,jD_ref,jH_ref,start_time,hour_ini,day_ini,day_end) &
+  !$OMP COPYIN(annee_ref,day_ref,itau_dyn,itau_phy,itaufin,calend) &
+  !     Copy all threadprivate variables from logic_mod
+  !$OMP COPYIN(purmats,forward,leapf,apphys,statcl,conser,apdiss,apdelq) &
+  !$OMP COPYIN(saison,ecripar,fxyhypb,ysinus,read_start,ok_guide) &
+  !$OMP COPYIN(ok_strato,ok_gradsfile,ok_limit,ok_etat0) &
+  !$OMP COPYIN(iflag_phys,iflag_trac)
   CALL leapfrog_loc(ucov,vcov,teta,ps,masse,phis,q,time_0)
   !$OMP END PARALLEL
Index: LMDZ5/branches/testing/libf/dyn3dmem/geopot_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/geopot_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/geopot_loc.F	(revision 2641)
@@ -26,7 +26,6 @@
 c   -------------
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comvert.h"
+      include "dimensions.h"
+      include "paramet.h"
 
 c   Arguments:
Index: LMDZ5/branches/testing/libf/dyn3dmem/groupe_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/groupe_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/groupe_loc.F	(revision 2641)
@@ -3,4 +3,5 @@
       USE Write_field_loc
       USE groupe_mod
+      USE comconst_mod, ONLY: ngroup
       implicit none
 
@@ -16,9 +17,7 @@
 c   pas besoin de w en entree.
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comconst.h"
-#include "comgeom2.h"
-#include "comvert.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom2.h"
 
 !     integer ngroup
Index: LMDZ5/branches/testing/libf/dyn3dmem/groupeun_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/groupeun_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/groupeun_loc.F	(revision 2641)
@@ -2,10 +2,10 @@
       USE parallel_lmdz
       USE Write_Field_p
+      USE comconst_mod, ONLY: ngroup
       IMPLICIT NONE
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comconst.h"
-#include "comgeom2.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom2.h"
 
       INTEGER jjmax,llmax,sb,se,jjb,jje
@@ -136,10 +136,10 @@
 
       USE parallel_lmdz
+      USE comconst_mod, ONLY: ngroup
       IMPLICIT NONE
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comconst.h"
-#include "comgeom2.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom2.h"
 
 !     INTEGER ngroup
Index: LMDZ5/branches/testing/libf/dyn3dmem/guide_loc_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/guide_loc_mod.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/guide_loc_mod.F90	(revision 2641)
@@ -69,5 +69,6 @@
   SUBROUTINE guide_init
 
-    USE control_mod
+    USE control_mod, ONLY: day_step
+    USE serre_mod, ONLY: grossismx
 
     IMPLICIT NONE
@@ -76,7 +77,4 @@
     INCLUDE "paramet.h"
     INCLUDE "netcdf.inc"
-
-    ! For grossismx:
-    include "serre.h"
 
     INTEGER                :: error,ncidpl,rid,rcod
@@ -346,4 +344,6 @@
     USE control_mod
     USE write_field_loc
+    USE comconst_mod, ONLY: cpp, daysec, dtvr, kappa
+    USE comvert_mod, ONLY: ap, bp, preff, presnivs, pressure_exner
     
     IMPLICIT NONE
@@ -351,6 +351,4 @@
     INCLUDE "dimensions.h"
     INCLUDE "paramet.h"
-    INCLUDE "comconst.h"
-    INCLUDE "comvert.h"
 
     ! Variables entree
@@ -748,4 +746,6 @@
   SUBROUTINE guide_zonave_u(typ,vsize,field)
 
+    USE comconst_mod, ONLY: pi
+    
     IMPLICIT NONE
 
@@ -753,5 +753,4 @@
     INCLUDE "paramet.h"
     INCLUDE "comgeom.h"
-    INCLUDE "comconst.h"
     
     ! input/output variables
@@ -819,4 +818,6 @@
   SUBROUTINE guide_zonave_v(typ,hsize,vsize,field)
 
+    USE comconst_mod, ONLY: pi
+    
     IMPLICIT NONE
 
@@ -824,5 +825,4 @@
     INCLUDE "paramet.h"
     INCLUDE "comgeom.h"
-    INCLUDE "comconst.h"
     
     ! input/output variables
@@ -890,11 +890,11 @@
   USE mod_hallo
   USE Bands
+  USE comconst_mod, ONLY: cpp, kappa
+  USE comvert_mod, ONLY: preff, pressure_exner, bp, ap, disvert_type
   IMPLICIT NONE
 
   include "dimensions.h"
   include "paramet.h"
-  include "comvert.h"
   include "comgeom2.h"
-  include "comconst.h"
 
   REAL, DIMENSION (iip1,jjb_u:jje_u),     INTENT(IN) :: psi ! Psol gcm
@@ -1012,6 +1012,6 @@
 !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
         DO l=1,llm
-	    DO j=jjbu,jjeu
-		DO i =1, iip1
+            DO j=jjbu,jjeu
+                DO i =1, iip1
                     pls(i,j,l)=(ap(l)+ap(l+1))/2.+psi(i,j)*(bp(l)+bp(l+1))/2.
                 ENDDO
@@ -1030,7 +1030,7 @@
    DO l = 1, llm
        DO j=jjbu,jjeu
-   	DO i =1, iip1
-   	    pls(i,j,l) = preff * ( pk(i,j,l)/cpp) ** unskap
-   	ENDDO
+           DO i =1, iip1
+               pls(i,j,l) = preff * ( pk(i,j,l)/cpp) ** unskap
+           ENDDO
        ENDDO
    ENDDO
@@ -1302,9 +1302,9 @@
         ! Calcul des nouvelles valeurs des niveaux de pression du guidage
         IF (guide_plevs.EQ.1) THEN
-	 CALL Register_Hallo_u(psnat1,1,1,2,2,1,Req)
-	 CALL Register_Hallo_u(psnat2,1,1,2,2,1,Req)
-	 CALL SendRequest(Req)
-!$OMP BARRIER
-	 CALL WaitRequest(Req)
+         CALL Register_Hallo_u(psnat1,1,1,2,2,1,Req)
+         CALL Register_Hallo_u(psnat2,1,1,2,2,1,Req)
+         CALL SendRequest(Req)
+!$OMP BARRIER
+         CALL WaitRequest(Req)
 !$OMP BARRIER
 !$OMP DO
@@ -1320,9 +1320,9 @@
             ENDDO
         ELSE IF (guide_plevs.EQ.2) THEN
-	 CALL Register_Hallo_u(pnat1,llm,1,2,2,1,Req)
-	 CALL Register_Hallo_u(pnat2,llm,1,2,2,1,Req)
-	 CALL SendRequest(Req)
-!$OMP BARRIER
-	 CALL WaitRequest(Req)
+         CALL Register_Hallo_u(pnat1,llm,1,2,2,1,Req)
+         CALL Register_Hallo_u(pnat2,llm,1,2,2,1,Req)
+         CALL SendRequest(Req)
+!$OMP BARRIER
+         CALL WaitRequest(Req)
 !$OMP BARRIER
 !$OMP DO
@@ -1370,11 +1370,12 @@
 ! Calcul des constantes de rappel alpha (=1/tau)
 
+    use comconst_mod, only: pi
+    use serre_mod, only: clat, clon, grossismx, grossismy
+    
     implicit none
 
     include "dimensions.h"
     include "paramet.h"
-    include "comconst.h"
     include "comgeom2.h"
-    include "serre.h"
 
 ! input arguments :
@@ -2127,4 +2128,6 @@
     USE parallel_lmdz
     USE mod_hallo, ONLY : gather_field_u, gather_field_v
+    USE comconst_mod, ONLY: pi
+    USE comvert_mod, ONLY: presnivs
     IMPLICIT NONE
 
@@ -2133,6 +2136,4 @@
     INCLUDE "netcdf.inc"
     INCLUDE "comgeom2.h"
-    INCLUDE "comconst.h"
-    INCLUDE "comvert.h"
     
     ! Variables entree
Index: LMDZ5/branches/testing/libf/dyn3dmem/iniacademic_loc.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/iniacademic_loc.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/iniacademic_loc.F90	(revision 2641)
@@ -18,4 +18,10 @@
 #endif
   USE Write_Field
+  USE comconst_mod, ONLY: cpp, kappa, g, daysec, dtvr, pi, im, jm
+  USE logic_mod, ONLY: iflag_phys, read_start
+  USE comvert_mod, ONLY: ap, bp, preff, presnivs, pressure_exner
+  USE temps_mod, ONLY: annee_ref, day_ini, day_ref
+  USE ener_mod, ONLY: etot0,ptot0,ztot0,stot0,ang0
+
 
   !   Author:    Frederic Hourdin      original: 15/01/93
@@ -30,12 +36,7 @@
   include "dimensions.h"
   include "paramet.h"
-  include "comvert.h"
-  include "comconst.h"
   include "comgeom.h"
   include "academic.h"
-  include "ener.h"
-  include "temps.h"
   include "iniprint.h"
-  include "logic.h"
 
   !   Arguments:
Index: LMDZ5/branches/testing/libf/dyn3dmem/initdynav_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/initdynav_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/initdynav_loc.F	(revision 2641)
@@ -14,4 +14,8 @@
        use com_io_dyn_mod, only : histaveid,histvaveid,histuaveid,       &
      &        dynhistave_file,dynhistvave_file,dynhistuave_file
+       USE comconst_mod, ONLY: pi
+       USE comvert_mod, ONLY: presnivs
+       USE temps_mod, ONLY: itau_dyn
+       
        implicit none
 
@@ -41,15 +45,9 @@
 C
 C   Declarations
-#include "dimensions.h"
-#include "paramet.h"
-#include "comconst.h"
-#include "comvert.h"
-#include "comgeom.h"
-#include "temps.h"
-#include "ener.h"
-#include "logic.h"
-#include "description.h"
-#include "serre.h"
-#include "iniprint.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom.h"
+      include "description.h"
+      include "iniprint.h"
 
 C   Arguments
Index: LMDZ5/branches/testing/libf/dyn3dmem/initfluxsto_p.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/initfluxsto_p.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/initfluxsto_p.F	(revision 2641)
@@ -13,4 +13,7 @@
        use Write_field
        use misc_mod
+       USE comconst_mod, ONLY: pi
+       USE comvert_mod, ONLY: nivsigs
+       USE temps_mod, ONLY: annee_ref, day_ref, itau_dyn
        
       implicit none
@@ -43,15 +46,9 @@
 C
 C   Declarations
-#include "dimensions.h"
-#include "paramet.h"
-#include "comconst.h"
-#include "comvert.h"
-#include "comgeom.h"
-#include "temps.h"
-#include "ener.h"
-#include "logic.h"
-#include "description.h"
-#include "serre.h"
-#include "iniprint.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom.h"
+      include "description.h"
+      include "iniprint.h"
 
 C   Arguments
@@ -106,6 +103,6 @@
       CALL ymds2ju(zan, 1, idayref, 0.0, zjulian)
       tau0 = itau_dyn
-	
-	do jj = 1, jjp1
+        
+        do jj = 1, jjp1
         do ii = 1, iip1
           rlong(ii,jj) = rlonu(ii) * 180. / pi
@@ -165,6 +162,6 @@
      .             1, iip1, 1, jjn,tau0, zjulian, tstep, vhoriid,
      .             filevid,dynv_domain_id)
-	
-      rl(1,1) = 1.	
+        
+      rl(1,1) = 1.
       
       if (mpi_rank==0) then
@@ -191,5 +188,5 @@
       call histhori(fileid, iip1, rlong(:,jjb:jje),jjn,rlat(:,jjb:jje),
      .             'scalar','Grille points scalaires', thoriid)
-	
+        
 C
 C  Appel a histvert pour la grille verticale
@@ -211,6 +208,6 @@
 C
 C  Appels a histdef pour la definition des variables a sauvegarder
-	
-	CALL histdef(fileid, "phis", "Surface geop. height", "-",
+        
+        CALL histdef(fileid, "phis", "Surface geop. height", "-",
      .                iip1,jjn,thoriid, 1,1,1, -99, 32,
      .                "once", t_ops, t_wrt)
@@ -219,8 +216,8 @@
      .                iip1,jjn,thoriid, 1,1,1, -99, 32,
      .                "once", t_ops, t_wrt)
-	
+        
         if (mpi_rank==0) then
-	
-	CALL histdef(filedid, "dtvr", "tps dyn", "s",
+        
+        CALL histdef(filedid, "dtvr", "tps dyn", "s",
      .                1,1,dhoriid, 1,1,1, -99, 32,
      .                "once", t_ops, t_wrt)
@@ -289,5 +286,5 @@
         if (mpi_rank==0) call histsync(filedid)
       endif
-	
+        
 #else
       write(lunout,*)'initfluxsto_p: Needs IOIPSL to function'
Index: LMDZ5/branches/testing/libf/dyn3dmem/inithist_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/inithist_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/inithist_loc.F	(revision 2641)
@@ -14,4 +14,8 @@
        use com_io_dyn_mod, only : histid,histvid,histuid,               &
      &                        dynhist_file,dynhistv_file,dynhistu_file
+       USE comconst_mod, ONLY: pi
+       USE comvert_mod, ONLY: presnivs
+       USE temps_mod, ONLY: itau_dyn
+       
        implicit none
 
@@ -40,15 +44,9 @@
 C
 C   Declarations
-#include "dimensions.h"
-#include "paramet.h"
-#include "comconst.h"
-#include "comvert.h"
-#include "comgeom.h"
-#include "temps.h"
-#include "ener.h"
-#include "logic.h"
-#include "description.h"
-#include "serre.h"
-#include "iniprint.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom.h"
+      include "description.h"
+      include "iniprint.h"
 
 C   Arguments
Index: LMDZ5/branches/testing/libf/dyn3dmem/integrd_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/integrd_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/integrd_loc.F	(revision 2641)
@@ -12,4 +12,9 @@
       USE integrd_mod
       USE infotrac, ONLY: ok_iso_verif ! ajout CRisi
+      USE comconst_mod, ONLY: pi
+      USE logic_mod, ONLY: leapf
+      USE comvert_mod, ONLY: ap, bp
+      USE temps_mod, ONLY: dt
+      
       IMPLICIT NONE
 
@@ -30,14 +35,8 @@
 c   -------------
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comconst.h"
-#include "comgeom.h"
-#include "comvert.h"
-#include "logic.h"
-#include "temps.h"
-#include "serre.h"
-#include "iniprint.h"
-!      include 'mpif.h'
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom.h"
+      include "iniprint.h"
 
 c   Arguments:
@@ -335,5 +334,5 @@
       ije=ij_end
 
-	 if (planet_type.eq."earth") then
+         if (planet_type.eq."earth") then
 ! Earth-specific treatment of first 2 tracers (water)
 c$OMP BARRIER
@@ -452,6 +451,6 @@
           DO l = 1, llm
             massem1(ijb:ije,l)=massescr(ijb:ije,l)
-	  ENDDO
-c$OMP END DO NOWAIT	  
+          ENDDO
+c$OMP END DO NOWAIT          
       END IF
 c$OMP BARRIER
Index: LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F	(revision 2641)
@@ -32,4 +32,11 @@
        use exner_hyb_loc_m, only: exner_hyb_loc
        use exner_milieu_loc_m, only: exner_milieu_loc
+       USE comconst_mod, ONLY: cpp, dtvr, ihf
+       USE comvert_mod, ONLY: ap, bp, pressure_exner
+       USE logic_mod, ONLY: iflag_phys,ok_guide,forward,leapf,apphys,
+     &                      statcl,conser,apdiss,purmats,ok_strato
+       USE temps_mod, ONLY: itaufin,jD_ref,jH_ref,day_ini,
+     &                        day_ref,start_time,dt
+       
       IMPLICIT NONE
 
@@ -65,19 +72,11 @@
 c   -------------
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comconst.h"
-#include "comdissnew.h"
-#include "comvert.h"
-#include "comgeom.h"
-#include "logic.h"
-#include "temps.h"
-#include "ener.h"
-#include "description.h"
-#include "serre.h"
-!#include "com_io_dyn.h"
-#include "iniprint.h"
-#include "academic.h"
-!      include "mpif.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comdissnew.h"
+      include "comgeom.h"
+      include "description.h"
+      include "iniprint.h"
+      include "academic.h"
       
       REAL,INTENT(IN) :: time_0 ! not used
@@ -472,5 +471,5 @@
 cym      apphys = .FALSE.
       statcl = .FALSE.
-      conser = .FALSE. ! ie: no output of control variables to stdout in //
+!     conser = .FALSE. ! ie: no output of control variables to stdout in //
       
       if (firstCaldyn) then
@@ -700,4 +699,7 @@
 
 c$OMP MASTER
+      if (mpi_rank==0.AND.conser) THEN
+         WRITE(lunout,*) 'leapfrog_loc, Time step: ',itau,' Day:',time
+      ENDIF
       call VTe(VTcaldyn)
 c$OMP END MASTER      
@@ -1635,5 +1637,5 @@
             IF( MOD(itau,iecri).EQ.0) THEN
              ! Ehouarn: output only during LF or Backward Matsuno
-	     if (leapf.or.(.not.leapf.and.(.not.forward))) then
+             if (leapf.or.(.not.leapf.and.(.not.forward))) then
 
 c$OMP BARRIER
@@ -1645,5 +1647,5 @@
 #ifdef CPP_IOIPSL
              if (ok_dyn_ins) then
-	         CALL writehist_loc(itau,vcov,ucov,teta,pk,phi,q,
+                 CALL writehist_loc(itau,vcov,ucov,teta,pk,phi,q,
      &                              masse,ps,phis)
              endif
Index: LMDZ5/branches/testing/libf/dyn3dmem/logic_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/logic_mod.F90	(revision 2641)
+++ LMDZ5/branches/testing/libf/dyn3dmem/logic_mod.F90	(revision 2641)
@@ -0,0 +1,45 @@
+!
+! $Id: $
+!
+MODULE logic_mod
+
+IMPLICIT NONE
+
+  LOGICAL purmats ! true if time stepping is purely Matsuno scheme
+                  ! false implies Matsuno-Leapfrog time stepping scheme
+  LOGICAL forward ! true if during forward phase of Matsuno step
+  LOGICAL leapf ! true if during a leapfrog time stepping step
+  LOGICAL apphys ! true if during a time step when physics will be called
+  LOGICAL statcl
+  LOGICAL conser
+  LOGICAL apdiss ! true if during a time step when dissipation will be called
+  LOGICAL apdelq
+  LOGICAL saison
+  LOGICAL ecripar
+  LOGICAL fxyhypb ! true if using hyperbolic function discretization
+                  ! for latitudinal grid 
+  LOGICAL ysinus ! true if using sine function discretiation
+                 ! for latitudinal grid
+  LOGICAL read_start ! true if reading a start.nc file to initialize fields
+  LOGICAL ok_guide ! true if nudging
+  LOGICAL ok_strato
+  LOGICAL ok_gradsfile
+  LOGICAL ok_limit
+  LOGICAL ok_etat0
+  LOGICAL hybrid ! vertical coordinate is hybrid if true (sigma otherwise)
+                 ! (only used if disvert_type==2)
+  INTEGER iflag_phys ! type of physics to call: 0 none, 1: phy*** package,
+                     ! 2: Held & Suarez, 101-200: aquaplanets & terraplanets
+  INTEGER iflag_trac
+
+!$OMP THREADPRIVATE(purmats,forward,leapf,apphys,statcl,conser, &
+!$OMP     apdiss,apdelq,saison,ecripar,fxyhypb,ysinus, &
+!$OMP     read_start,ok_guide,ok_strato,ok_gradsfile, &
+!$OMP     ok_limit,ok_etat0,hybrid)
+!$OMP THREADPRIVATE(iflag_phys,iflag_trac)
+
+!WARNING: when adding a threadprivate variable in this module
+!        do not forget to add it to the copyin clause when opening an OpenMP
+!        parallel section. e.g. in gcm before call leapfrog_loc 
+
+END MODULE logic_mod
Index: LMDZ5/branches/testing/libf/dyn3dmem/massbarxy_loc.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/massbarxy_loc.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/massbarxy_loc.F90	(revision 2641)
@@ -10,5 +10,4 @@
   include "dimensions.h"
   include "paramet.h"
-  include "comconst.h"
   include "comgeom.h"
 !===============================================================================
Index: LMDZ5/branches/testing/libf/dyn3dmem/massdair_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/massdair_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/massdair_loc.F	(revision 2641)
@@ -16,8 +16,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comconst.h"
-#include "comgeom.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom.h"
 c
 c  .....   arguments  ....
Index: LMDZ5/branches/testing/libf/dyn3dmem/mod_hallo.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/mod_hallo.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/mod_hallo.F90	(revision 2641)
@@ -1411,5 +1411,5 @@
          
 #ifdef CPP_MPI
-         call MPI_ISSEND(Buffer(req%Pos),SizeBuffer,MPI_REAL_LMDZ,rank,a_request%tag+1000*omp_rank,     &
+         call MPI_ISEND(Buffer(req%Pos),SizeBuffer,MPI_REAL_LMDZ,rank,a_request%tag+1000*omp_rank,     &
                          COMM_LMDZ,Req%MSG_Request,ierr)
 #endif
Index: LMDZ5/branches/testing/libf/dyn3dmem/parallel_lmdz.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/parallel_lmdz.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/parallel_lmdz.F90	(revision 2641)
@@ -575,5 +575,5 @@
 !$OMP CRITICAL (MPI)
 #ifdef CPP_MPI
-          call MPI_ISSEND(Buffer_send_up,Buffer_Size,MPI_REAL8,MPI_Rank-1,1,     &
+          call MPI_ISEND(Buffer_send_up,Buffer_Size,MPI_REAL8,MPI_Rank-1,1,     &
                           COMM_LMDZ,Request(NbRequest),ierr)
 #endif
@@ -590,5 +590,5 @@
 !$OMP CRITICAL (MPI)
 #ifdef CPP_MPI
-          call MPI_ISSEND(Buffer_send_down,Buffer_Size,MPI_REAL8,MPI_Rank+1,1,     &
+          call MPI_ISEND(Buffer_send_down,Buffer_Size,MPI_REAL8,MPI_Rank+1,1,     &
                           COMM_LMDZ,Request(NbRequest),ierr)
 #endif
Index: LMDZ5/branches/testing/libf/dyn3dmem/qminimum_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/qminimum_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/qminimum_loc.F	(revision 2641)
@@ -7,7 +7,6 @@
 c             pour l'eau vapeur et l'eau liquide
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comvert.h"
+      include "dimensions.h"
+      include "paramet.h"
 c
       INTEGER nqtot ! CRisi: on remplace nq par nqtot
Index: LMDZ5/branches/testing/libf/dyn3dmem/sw_case_williamson91_6_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/sw_case_williamson91_6_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/sw_case_williamson91_6_loc.F	(revision 2641)
@@ -27,4 +27,6 @@
 c=======================================================================
       USE parallel_lmdz
+      USE comconst_mod, ONLY: cpp, omeg, rad
+      USE comvert_mod, ONLY: ap, bp, preff
 
       IMPLICIT NONE
@@ -33,10 +35,8 @@
 c   ---------------
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comvert.h"
-#include "comconst.h"
-#include "comgeom.h"
-#include "iniprint.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom.h"
+      include "iniprint.h"
 
 c   Arguments:
Index: LMDZ5/branches/testing/libf/dyn3dmem/temps_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/temps_mod.F90	(revision 2641)
+++ LMDZ5/branches/testing/libf/dyn3dmem/temps_mod.F90	(revision 2641)
@@ -0,0 +1,33 @@
+!
+! $Id: temps_mod.F90 -1   $
+!
+MODULE temps_mod
+
+IMPLICIT NONE  
+
+  INTEGER   itaufin ! total number of dynamical steps for the run
+  INTEGER   itau_dyn
+  INTEGER   itau_phy
+  INTEGER   day_ini ! initial day # of simulation sequence
+  INTEGER   day_end ! final day # ; i.e. day # when this simulation ends
+  INTEGER   annee_ref
+  INTEGER   day_ref
+  REAL      dt ! (dynamics) time step (changes if doing Matsuno or LF step)
+  REAL      jD_ref ! reference julian day date (beginning of experiment)
+  REAL      jH_ref ! reference julian "hour" of reference julian date
+  REAL      start_time
+  CHARACTER (len=10) :: calend ! calendar type
+
+  ! Additionnal Mars stuff:
+  REAL hour_ini ! initial fraction of day of simulation sequence (0=<hour_ini<1)
+
+!$OMP THREADPRIVATE(dt,jD_ref,jH_ref,start_time,hour_ini,                        &
+!$OMP                day_ini,day_end,annee_ref,day_ref,itau_dyn,itau_phy,itaufin,&
+!$OMP                calend)        
+
+!WARNING: when adding a threadprivate variable in this module
+!        do not forget to add it to the copyin clause when opening an OpenMP
+!        parallel section. e.g. in gcm before call leapfrog_loc and/or
+!        possibly in iniphysiq
+
+END MODULE temps_mod
Index: LMDZ5/branches/testing/libf/dyn3dmem/top_bound_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/top_bound_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/top_bound_loc.F	(revision 2641)
@@ -4,11 +4,13 @@
       SUBROUTINE top_bound_loc(vcov,ucov,teta,masse,dt)
       USE parallel_lmdz
+      USE comconst_mod, ONLY: iflag_top_bound, mode_top_bound,
+     &                        tau_top_bound
+      USE comvert_mod, ONLY: presnivs, preff, scaleheight
+
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comconst.h"
-#include "comvert.h"
-#include "comgeom2.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom2.h"
 
 
@@ -40,5 +42,5 @@
 ! NB: top_bound sponge is only called from leapfrog if ok_strato=.true.
 
-! sponge parameters: (loaded/set in conf_gcm.F ; stored in comconst.h)
+! sponge parameters: (loaded/set in conf_gcm.F ; stored in comconst_mod)
 !    iflag_top_bound=0 for no sponge
 !    iflag_top_bound=1 for sponge over 4 topmost layers
@@ -74,5 +76,5 @@
       REAL tzon(jjb_u:jje_u,llm)
       
-      integer i	
+      integer i
       REAL,SAVE :: rdamp(llm)
       real,save :: lambda(llm) ! inverse or quenching time scale (Hz)
Index: LMDZ5/branches/testing/libf/dyn3dmem/tourpot_loc.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/tourpot_loc.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/tourpot_loc.F90	(revision 2641)
@@ -11,5 +11,4 @@
   include "paramet.h"
   include "comgeom.h"
-  include "logic.h"
 !===============================================================================
 ! Arguments:
Index: LMDZ5/branches/testing/libf/dyn3dmem/vitvert_loc.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/vitvert_loc.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/vitvert_loc.F90	(revision 2641)
@@ -6,8 +6,9 @@
 ! Purpose: Compute vertical speed at sigma levels.
   USE parallel_lmdz
+  USE comvert_mod, ONLY: bp
+  
   IMPLICIT NONE
   include "dimensions.h"
   include "paramet.h"
-  include "comvert.h"
 !===============================================================================
 ! Arguments:
Index: LMDZ5/branches/testing/libf/dyn3dmem/vlsplt_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/vlsplt_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dyn3dmem/vlsplt_loc.F	(revision 2641)
@@ -17,9 +17,6 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "logic.h"
-#include "comvert.h"
-#include "comconst.h"
+      include "dimensions.h"
+      include "paramet.h"
 c
 c
@@ -417,12 +414,10 @@
       USE parallel_lmdz
       USE infotrac, ONLY : nqtot,nqfils,nqdesc,iqfils ! CRisi
+      USE comconst_mod, ONLY: pi
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "logic.h"
-#include "comvert.h"
-#include "comconst.h"
-#include "comgeom.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom.h"
 c
 c
@@ -875,9 +870,6 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "logic.h"
-#include "comvert.h"
-#include "comconst.h"
+      include "dimensions.h"
+      include "paramet.h"
 c
 c
